Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait PatternExpander [Pattern, Type] extends AnyRef

  An extractor returns: F1, F2, ..., Fi, opt[Seq[E] or E*] A case matches: P1, P2, ..., Pj, opt[Seq[E]] Put together: P1/F1, P2/F2, ...

  An extractor returns: F1, F2, ..., Fi, opt[Seq[E] or E*] A case matches: P1, P2, ..., Pj, opt[Seq[E]] Put together: P1/F1, P2/F2, ... Pi/Fi, Pi+1/E, Pi+2/E, ... Pj/E, opt[Seq[E]]

  Here Pm/Fi is the last pattern to match the fixed arity section.

  productArity: the value of i, i.e. the number of non-sequence types in the extractor nonStarArity: the value of j, i.e. the number of non-star patterns in the case definition elementArity: j - i, i.e. the number of non-star patterns which must match sequence elements starArity: 1 or 0 based on whether there is a star (sequence-absorbing) pattern totalArity: nonStarArity + starArity, i.e. the number of patterns in the case definition

  Note that productArity is a function only of the extractor, and nonStar/star/totalArity are all functions of the patterns. The key value for aligning and typing the patterns is elementArity, as it is derived from both sets of information.

  Definition Classes
    patmat
- Aligned
- Extractor
- NoRepeated
- Patterns
- Repeated
- TypedPat

c

scala.tools.nsc.transform.patmat.PatternExpander

# Repeated 

###

#### sealed case class Repeated(sequenceType: Type, elementType: Type, repeatedType: Type) extends Product with Serializable

It's not optimal that we're carrying both sequence and repeated type here, but the implementation requires more unraveling before it can be avoided.

sequenceType is Seq[T], elementType is T, repeatedType is T*.

Source
  PatternExpander.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, AnyRef, Any
Known Subclasses
NoRepeated
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Repeated
2. Serializable
3. Serializable
4. Product
5. Equals
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Repeated(sequenceType: Type, elementType: Type, repeatedType: Type)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Repeated to any2stringadd[Repeated] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Repeated, B)
   Implicit
     This member is added by an implicit conversion from Repeated to ArrowAssoc[Repeated] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def elementList: collection.immutable.List[Type]
9.  val elementType: Type
10.  def ensuring(cond: (Repeated) ⇒ Boolean, msg: ⇒ Any): Repeated
    Implicit
      This member is added by an implicit conversion from Repeated to Ensuring[Repeated] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: (Repeated) ⇒ Boolean): Repeated
    Implicit
      This member is added by an implicit conversion from Repeated to Ensuring[Repeated] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean, msg: ⇒ Any): Repeated
    Implicit
      This member is added by an implicit conversion from Repeated to Ensuring[Repeated] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean): Repeated
    Implicit
      This member is added by an implicit conversion from Repeated to Ensuring[Repeated] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
15.  def exists: Boolean
16.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
17.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Repeated to StringFormat[Repeated] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
18.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
19.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
20.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
21.  final def notify(): Unit
    Definition Classes
      AnyRef
22.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
23.  def repeatedList: collection.immutable.List[Type]
24.  val repeatedType: Type
25.  def sequenceList: collection.immutable.List[Type]
26.  val sequenceType: Type
27.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
28.  def toString(): String
    Definition Classes
      Repeated → AnyRef → Any
29.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
30.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  def →[B](y: B): (Repeated, B)
    Implicit
      This member is added by an implicit conversion from Repeated to ArrowAssoc[Repeated] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Repeated to any2stringadd[Repeated]

### Inherited by implicit conversion StringFormat from Repeated to StringFormat[Repeated]

### Inherited by implicit conversion Ensuring from Repeated to Ensuring[Repeated]

### Inherited by implicit conversion ArrowAssoc from Repeated to ArrowAssoc[Repeated]

### Ungrouped